Index: arch/m88k/m88k/process.S
===================================================================
RCS file: /cvs/src/sys/arch/m88k/m88k/process.S,v
retrieving revision 1.16
diff -u -r1.16 process.S
--- arch/m88k/m88k/process.S	12 May 2007 19:59:52 -0000	1.16
+++ arch/m88k/m88k/process.S	25 Sep 2007 09:53:46 -0000
@@ -35,242 +35,63 @@
 #include <machine/psl.h>
 #include <machine/intr.h>
 
-#ifdef DIAGNOSTIC
-	data
-	align	4
-ASLOCAL(swchanpanic)
-	string	"switch wchan %x\0"
-	align	4
-ASLOCAL(swsrunpanic)
-	string	"switch SRUN %x\0"
-
-	text
-	align	8
-ASLOCAL(Lswchanpanic)
-	or.u	r2, r0, hi16(_ASM_LABEL(swchanpanic))
-	or	r2, r2, lo16(_ASM_LABEL(swchanpanic))
-	bsr.n	_C_LABEL(panic)
-	 or	r3, r0, r9
-
-ASLOCAL(Lswsrunpanic)
-	or.u	r2, r0, hi16(_ASM_LABEL(swsrunpanic))
-	or	r2, r2, lo16(_ASM_LABEL(swsrunpanic))
-	bsr.n	_C_LABEL(panic)
-	 or	r3, r0, r9
-#endif
-
 /*
- * void switch_exit(struct proc *p)
+ * void cpu_idle_enter()
  *
- * Do the final work to exit from a process. After switching to the
- * idle stack and pcb, invoke exit2() on behalf of the exiting process,
- * then continue into cpu_switch() to select another process to run.
+ * Enable all interrupts and lower spl. This actually enables interrupts
+ * in the psr; bootstrap of secondary processors depends on this.
  */
-
-ENTRY(switch_exit)
-	/*
-	 * Disable interrupts since we are about to change the kernel
-	 * stack.
-	 */
-	ldcr	r3, PSR
-	set	r3, r3, 1<PSR_INTERRUPT_DISABLE_BIT>
-	stcr	r3, PSR
+ENTRY(cpu_idle_enter)
+	ldcr	r2, PSR
+	clr	r2, r2, 1<PSR_INTERRUPT_DISABLE_BIT>
+	stcr	r2, PSR
 	FLUSH_PIPELINE
 
-	/*
-	 * Change pcb to idle u. area, i.e., set r31 to top of stack
-	 * and set curpcb to point to the cpu's idle stack.
-	 * r2 contains proc *p.
-	 */
-	ldcr	r10, CPU
-	ld	r30, r10, CI_IDLE_PCB
-	addu	r31, r30, USIZE				/* now on idle stack */
-	st	r30, r10, CI_CURPCB			/* curpcb = idle_pcb */
-
-	/* Schedule the vmspace and stack to be freed. */
-	bsr.n	_C_LABEL(exit2)
-	 st	r0, r10, CI_CURPROC			/* curproc = NULL */
-
-	/*
-	 * exit2() has acquired the scheduler lock for us. Jump into
-	 * cpu_switch(), after the context save since we do not need
-	 * to save anything.
-	 */
-	br	_ASM_LABEL(cpu_switch_search)
+	br.n	_C_LABEL(setipl)
+	 or	r2, r0, IPL_NONE
 
 /*
- * void cpu_switch(struct proc *p)
+ * void cpu_idle_leave()
  *
- * Find a runnable process and switch to it. On entry, the scheduler lock is
- * held; it has to be released before returning to the process.
+ * Raise ipl to IPL_SCHED, but do not attempt to disable interrupts.
+ */
+ENTRY(cpu_idle_leave)
+	br.n	_C_LABEL(setipl)
+	 or	r2, r0, IPL_SCHED
+
+/*
+ * void cpu_switchto(struct proc *oldproc, struct proc *newproc)
  *
- * Note that this code ignores its proc parameter and assumes it has the
- * same value as curproc. This may change in mi_switch() in the future,
- * be careful.
+ * Switch context from oldproc to newproc. oldproc may be NULL if there is
+ * no need to save the current context.
  */
-ENTRY(cpu_switch)
+ENTRY(cpu_switchto)
 	/*
-	 * Disable interrupts, we do not want to be disturbed while
-	 * saving context.
+	 * Save state of previous process in its pcb if required.
 	 */
-	ldcr	r2, PSR
-	set	r2, r2, 1<PSR_INTERRUPT_DISABLE_BIT>
-	stcr	r2, PSR
-	FLUSH_PIPELINE
+	bcnd	eq0, r2, 1f
 
-	/*
-	 * Save state of previous process in its pcb, and pmap_deactivate()
-	 * the process.
-	 */
 	ldcr	r2,  CPU
 	ld	r2,  r2,  CI_CURPCB
 	st	r1,  r2,  PCB_PC		/* save return address */
 	bsr	_ASM_LABEL(__savectx)
 	/* note that we don't need to recover r1 at this point */
 
+1:
 	ldcr	r11, CPU
-	ld	r2,  r11, CI_CURPROC
-
-	/*
-	 * Note that we can still use curpcb as our stack after
-	 * pmap_deactivate() has been called, as it does not affect the u
-	 * area mappings.
-	 */
-	bsr.n	_C_LABEL(pmap_deactivate)
-	 st	r0,  r11, CI_CURPROC		/* curproc = NULL */
-
-#ifdef MULTIPROCESSOR
-	/*
-	 * We need to switch to the processor's idle stack now (in case the
-	 * process we are using the stack of gets scheduled on another
-	 * processor).
-	 */
-	ldcr	r10, CPU
-	ld	r30, r10, CI_IDLE_PCB
-	addu	r31, r30, USIZE				/* now on idle stack */
-	st	r30, r10, CI_CURPCB			/* curpcb = idle_pcb */
-#endif
-
-ASLOCAL(cpu_switch_search)
-	/*
-	 * This is the start of the idle loop. Find the highest-priority
-	 * queue that isn't empty, then take the first proc from that queue.
-	 */
-	or.u	r7, r0, hi16(_C_LABEL(whichqs))
-	ld	r7, r7, lo16(_C_LABEL(whichqs))
-	bcnd	ne0, r7, _ASM_LABEL(cpu_switch_found)
+	st	r3,  r11, CI_CURPROC			/* curproc = newproc */
 
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	bsr	_C_LABEL(sched_unlock_idle)
-#endif
-
-#ifdef MULTIPROCESSOR
-ASGLOBAL(cpu_switch_idle)
-#else
-ASLOCAL(cpu_switch_idle)
-#endif
-	/*
-	 * There were no runnable processes. Enable all interrupts and
-	 * busy-wait for this to change.
-	 * Note that, besides doing setipl(IPL_NONE), this will actually enable
-	 * interrupts in the psr. Bootstrap of secondary processors
-	 * relies upon this.
-	 */
-	ldcr	r2, PSR
-	clr	r2, r2, 1<PSR_INTERRUPT_DISABLE_BIT>
-	stcr	r2, PSR
-	FLUSH_PIPELINE
-
-	bsr.n	_C_LABEL(setipl)
-	 or	r2, r0, IPL_NONE
-
-	or.u	r7, r0, hi16(_C_LABEL(whichqs))
-	ld	r7, r7, lo16(_C_LABEL(whichqs))
-	bcnd	eq0, r7, _ASM_LABEL(cpu_switch_idle)
-	/* XXX run fancy things here, such as page zeroing... */
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	bsr	_C_LABEL(sched_lock_idle)
-#endif
-
-ASLOCAL(cpu_switch_found)
-	/*
-	 * Disable interrupts.
-	 */
-	ldcr	r2, PSR
-	set	r2, r2, 1<PSR_INTERRUPT_DISABLE_BIT>
-	stcr	r2, PSR
-	FLUSH_PIPELINE
-
-	/*
-	 * An interrupt could have occured between the last whichqs check
-	 * and the call to setipl(). Check again that whichqs is nonzero.
-	 */
-	or.u	r7, r0, hi16(_C_LABEL(whichqs))	/* reload whichqs */
-	ld	r7, r7, lo16(_C_LABEL(whichqs))
-	bcnd	eq0, r7, _ASM_LABEL(cpu_switch_search)
-
-	/* XXX use ff1, like powerpc... needs *runqueue() adjustments */
-	xor	r6, r6, r6		/* set r6 to 0 */
-1:	bb1	0,  r7, 2f		/* if rightmost bit set, done */
-	extu	r7, r7, 0<1>		/* else, right shift whichqs, */
-	br.n	1b			/* increment r6, and repeat */
-	 addu	r6, r6, 1
-2:
-	or.u	r7, r0, hi16(_C_LABEL(qs))
-	or	r7, r7, lo16(_C_LABEL(qs))
-
-	/*
-	 * Need to make
-	 *	p->p_forw->p_back = p->p_back and
-	 *	p->p_back->p_forw = p->p_forw where
-	 *	p is q->p_forw.
-	 * Remember that q->p_forw == p and p->p_back == q.
-	 */
-
-	lda.d	r8,  r7[r6]	/* r8 = &qs[ff1(whichqs)] */
-	ld	r9,  r8, P_FORW	/* r8 is q, r9 is p */
-
-	ld	r12, r9, P_FORW	/* r12 = p->p_forw */
-	st	r8, r12, P_BACK	/* p->p_forw->p_back = q (p->p_back) */
-	st	r12, r8, P_FORW	/* q->p_forw = p->p_forw */
-	lda.d	r8,  r7[r6]	/* reload r8 with qs[ff1(whichqs)] */
-	ld	r12, r8, P_FORW	/* q->p_forw */
-	cmp	r12, r12, r8	/* q == q->p_forw; anyone left on queue? */
-	bb1	ne,  r12, 3f	/* yes, skip clearing bit in whichqs  */
-
-	or	r12, r0, 1
-	mak	r12, r12, r6
-	or.u	r7,  r0, hi16(_C_LABEL(whichqs))
-	ld	r8,  r7, lo16(_C_LABEL(whichqs))
-	and.c	r8,  r8, r12	/* whichqs &= ~the bit */
-	st	r8,  r7, lo16(_C_LABEL(whichqs))
-3:
-#ifdef DIAGNOSTIC
-	ld	r2, r9, P_WCHAN
-	bcnd	ne0, r2, _ASM_LABEL(Lswchanpanic)
-	ld.b	r2, r9, P_STAT
-	cmp	r2, r2, SRUN
-	bb1	ne, r2, _ASM_LABEL(Lswsrunpanic)
-#endif
-
-	ldcr	r11, CPU
-	st	r0,  r11, CI_WANT_RESCHED		/* clear want_resched */
-
-	st	r9,  r11, CI_CURPROC			/* curproc = p */
 	or	r2,  r0,  SONPROC
-	st.b	r2,  r9,  P_STAT
+	st.b	r2,  r3,  P_STAT
 #ifdef MULTIPROCESSOR
-	st	r11, r9,  P_CPU				/* p->p_cpu = curcpu */
+	st	r11, r3,  P_CPU				/* p->p_cpu = curcpu */
 #endif
-
-	ld	r3,  r9,  P_ADDR
-	st	r0,  r9,  P_BACK			/* p->p_back = 0 */
-	st	r3,  r11, CI_CURPCB			/* curpcb = p->p_addr */
+	ld	r2,  r3,  P_ADDR
+	st	r2,  r11, CI_CURPCB			/* curpcb = p->p_addr */
 
 	/* pmap_activate() the process' pmap */
 	bsr.n	_C_LABEL(pmap_activate)
-	 or	r2, r0, r9
+	 or	r2, r0, r3
 
 	ldcr	r10,  CPU
 	ld	r10,  r10, CI_CURPCB
@@ -297,25 +118,9 @@
 	ld	r29, r10, PCB_R29
 	ld	r30, r10, PCB_R30	/* restore frame pointer & stack */
 	ld	r31, r10, PCB_SP
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	bsr.n	_C_LABEL(sched_unlock_idle)
-	 or	r14, r10, r0
-	ld	r1,  r14, PCB_PC
-	ld	r14, r14, PCB_R14
-#else
 	ld	r1,  r10, PCB_PC
-	ld	r14, r10, PCB_R14
-#endif
-
-	/*
-	 * Enable interrupts again.
-	 */
-	ldcr	r2, PSR
-	clr	r2, r2, 1<PSR_INTERRUPT_DISABLE_BIT>
-	stcr	r2, PSR
-	FLUSH_PIPELINE
-
-	jmp	r1
+	jmp.n	r1
+	 ld	r14, r10, PCB_R14
 
 /*
  * savectx(pcb)
Index: arch/m88k/m88k/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/m88k/m88k/vm_machdep.c,v
retrieving revision 1.15
diff -u -r1.15 vm_machdep.c
--- arch/m88k/m88k/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.15
+++ arch/m88k/m88k/vm_machdep.c	25 Sep 2007 09:53:47 -0000
@@ -136,20 +136,17 @@
 
 /*
  * cpu_exit is called as the last action during exit.
- * We release the address space and machine-dependent resources,
- * including the memory for the user structure and kernel stack.
- * Once finished, we call switch_exit, which switches to a temporary
- * pcb and stack and never returns.  We block memory allocation
- * until switch_exit has made things safe again.
+ *
+ * Block context switches and then call switch_exit() which will
+ * switch to another process thus we never return.
  */
 void
 cpu_exit(struct proc *p)
 {
-	splhigh();
+	(void)splhigh();
 
 	pmap_deactivate(p);
-	switch_exit(p);
-	/* NOTREACHED */
+	sched_exit(p);
 }
 
 /*
Index: arch/mac68k/mac68k/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/mac68k/mac68k/locore.s,v
retrieving revision 1.58
diff -u -r1.58 locore.s
--- arch/mac68k/mac68k/locore.s	15 May 2007 13:46:22 -0000	1.58
+++ arch/mac68k/mac68k/locore.s	25 Sep 2007 09:53:47 -0000
@@ -954,52 +954,18 @@
  */
 #include <m68k/m68k/support.s>
 
-/*
- * Use common m68k process manipulation routines.
- */
-#include <m68k/m68k/proc_subr.s>
-
 	.data
 GLOBAL(curpcb)
 	.long	0
 
 ASBSS(nullpcb,SIZEOF_PCB)
 
-/*
- * At exit of a process, do a switch for the last time.
- * Switch to a safe stack and PCB, and select a new process to run.  The
- * old stack and u-area will be freed by the reaper.
- */
-ENTRY(switch_exit)
-	movl	sp@(4),a0
-	/* save state into garbage pcb */
-	movl	#_ASM_LABEL(nullpcb),_C_LABEL(curpcb)
-	lea	_ASM_LABEL(tmpstk),sp	| goto a tmp stack
-
-	/* Schedule the vmspace and stack to be freed. */
-	movl	a0,sp@-			| exit2(p)
-	jbsr	_C_LABEL(exit2)
-	lea	sp@(4),sp		| pop args
-
-	jra	_C_LABEL(cpu_switch)
-
-/*
- * When no processes are on the runq, Swtch branches to Idle
- * to wait for something to come ready.
- */
-ASENTRY_NOPROFILE(Idle)
+ENTRY_NOPROFILE(cpu_idle_cycle)
 	stop	#PSL_LOWIPL
-	movw	#PSL_HIGHIPL,sr
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-	jra	Lsw1
-
-Lbadsw:
-	PANIC("switch")
-	/*NOTREACHED*/
+	rts
 
 /*
- * cpu_switch()
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  *
  * NOTE: On the mc68851 (318/319/330) we attempt to avoid flushing the
  * entire ATC.  The effort involved in selective flushing may not be
@@ -1009,55 +975,15 @@
  * user's PTEs have been changed (formerly denoted by the SPTECHG p_flag
  * bit).  For now, we just always flush the full ATC.
  */
-ENTRY(cpu_switch)
-	movl	_C_LABEL(curpcb),a0	| current pcb
-	movw	sr,a0@(PCB_PS)		| save sr before changing ipl
-#ifdef notyet
-	movl	CURPROC,sp@-		| remember last proc running
-#endif
-	clrl	CURPROC
+ENTRY(cpu_switchto)
+	movl	sp@(4), d0		| oldproc
+	beq	Lswnofpsave		| is NULL, don't save anything
 
 	/*
-	 * Find the highest-priority queue that isn't empty,
-	 * then take the first proc from that queue.
-	 */
-	movw	#PSL_HIGHIPL,sr		| lock out interrupts
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-Lsw1:
-	movl	d0,d1
-	negl	d0
-	andl	d1,d0
-	bfffo	d0{#0:#32},d1
-	eorib	#31,d1
-
-	movl	d1,d0
-	lslb	#3,d1			| convert queue number to index
-	addl	#_C_LABEL(qs),d1	| locate queue (q)
-	movl	d1,a1
-	movl	a1@(P_FORW),a0		| p = q->p_forw
-	cmpal	d1,a0			| anyone on queue?
-	jeq	Lbadsw			| no, panic
-	movl	a0@(P_FORW),a1@(P_FORW)	| q->p_forw = p->p_forw
-	movl	a0@(P_FORW),a1		| n = p->p_forw
-	movl	d1,a1@(P_BACK)		| n->p_back = q
-	cmpal	d1,a1			| anyone left on queue?
-	jne	Lsw2			| yes, skip
-	movl	_C_LABEL(whichqs),d1
-	bclr	d0,d1			| no, clear bit
-	movl	d1,_C_LABEL(whichqs)
-Lsw2:
-	movl	a0,CURPROC
-	clrl	_C_LABEL(want_resched)
-#ifdef notyet
-	movl	sp@+,a1
-	cmpl	a0,a1			| switching to same proc?
-	jeq	Lswdone			| yes, skip save and restore
-#endif
-	/*
 	 * Save state of previous process in its pcb.
 	 */
 	movl	_C_LABEL(curpcb),a1
+	movw	sr, a1@(PCB_PS)		| save sr before switching context
 	moveml	#0xFCFC,a1@(PCB_REGS)	| save non-scratch registers
 	movl	usp,a2			| grab USP (a2 has been saved)
 	movl	a2,a1@(PCB_USP)		| and save it
@@ -1070,16 +996,12 @@
 	jeq	Lswnofpsave		| yes, all done
 	fmovem	fp0-fp7,a2@(FPF_REGS)	| save FP general registers
 	fmovem	fpcr/fpsr/fpi,a2@(FPF_FPCR)	| save FP control registers
+
 Lswnofpsave:
+	movl	sp@(8), a0		| newproc
 
-#ifdef DIAGNOSTIC
-	tstl	a0@(P_WCHAN)
-	jne	Lbadsw
-	cmpb	#SRUN,a0@(P_STAT)
-	jne	Lbadsw
-#endif
+	movl	a0, CURPROC
 	movb	#SONPROC,a0@(P_STAT)
-	clrl	a0@(P_BACK)		| clear back link
 	movl	a0@(P_ADDR),a1		| get p_addr
 	movl	a1,_C_LABEL(curpcb)
 
Index: arch/mac68k/mac68k/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/mac68k/mac68k/vm_machdep.c,v
retrieving revision 1.39
diff -u -r1.39 vm_machdep.c
--- arch/mac68k/mac68k/vm_machdep.c	27 May 2007 20:59:25 -0000	1.39
+++ arch/mac68k/mac68k/vm_machdep.c	25 Sep 2007 09:53:47 -0000
@@ -119,19 +119,18 @@
 
 /*
  * cpu_exit is called as the last action during exit.
- * We release the address space and machine-dependent resources,
- * block context switches and then call switch_exit() which will
- * free our stack and user area and switch to another process.
- * Thus, we never return.
+ *
+ * Block context switches and then call switch_exit() which will
+ * switch to another process thus we never return.
  */
 void
 cpu_exit(p)
 	struct proc *p;
 {
-
 	(void)splhigh();
-	switch_exit(p);
-	/* NOTREACHED */
+
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/macppc/macppc/cpu.c
===================================================================
RCS file: /cvs/src/sys/arch/macppc/macppc/cpu.c,v
retrieving revision 1.43
diff -u -r1.43 cpu.c
--- arch/macppc/macppc/cpu.c	23 May 2007 23:40:21 -0000	1.43
+++ arch/macppc/macppc/cpu.c	25 Sep 2007 09:53:48 -0000
@@ -676,7 +676,7 @@
 cpu_hatch(void)
 {
 	volatile struct cpu_hatch_data *h = cpu_hatch_data;
-	int scratch, i;
+	int scratch, i, s;
 
         /* Initialize timebase. */
         __asm ("mttbl %0; mttbu %0; mttbl %0" :: "r"(0));
@@ -759,5 +759,12 @@
 
 	curcpu()->ci_ipending = 0;
 	curcpu()->ci_cpl = 0;
+
+	s = splhigh();
+	microuptime(&curcpu()->ci_schedstate.spc_runtime);
+	splx(s);
+
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 #endif
Index: arch/macppc/macppc/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/macppc/macppc/genassym.cf,v
retrieving revision 1.14
diff -u -r1.14 genassym.cf
--- arch/macppc/macppc/genassym.cf	22 Mar 2007 19:26:28 -0000	1.14
+++ arch/macppc/macppc/genassym.cf	25 Sep 2007 09:53:48 -0000
@@ -61,7 +61,6 @@
 struct	pcb
 member	PCB_PMR		pcb_pmreal
 member	pcb_sp
-member	pcb_spl
 member	PCB_FAULT	pcb_onfault
 
 struct	pmap
@@ -70,8 +69,6 @@
 member	PM_KERNELSR	pm_sr[PPC_KERNEL_SR]
 
 struct	proc
-member	p_forw
-member	p_back
 member	p_addr
 member	p_stat
 member	p_cpu
Index: arch/macppc/macppc/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/macppc/macppc/locore.S,v
retrieving revision 1.32
diff -u -r1.32 locore.S
--- arch/macppc/macppc/locore.S	20 Mar 2007 20:59:54 -0000	1.32
+++ arch/macppc/macppc/locore.S	25 Sep 2007 09:53:48 -0000
@@ -133,150 +133,41 @@
 	lis	%r3,_C_LABEL(cpu_hatch_stack)@ha
 	lwz	%r1,_C_LABEL(cpu_hatch_stack)@l(%r3)
 
-	bl	_C_LABEL(cpu_hatch)
-	bl	_C_LABEL(sched_lock_idle)
-	li	%r30,0
-	b	_C_LABEL(idle)
-#endif
-/*
- * No processes are runnable, so loop waiting for one.
- * Separate label here for accounting purposes.
- */
-	.globl	_C_LABEL(idle)
-	.type	_C_LABEL(idle),@function
-_C_LABEL(idle):
-	mfmsr	%r3
-	/* disable interrupts while manipulating runque */
-	andi.	%r3,%r3,~PSL_EE@l
-	mtmsr	%r3
-
-	lis	%r8,_C_LABEL(whichqs)@ha
-	lwz	%r9,_C_LABEL(whichqs)@l(%r8)
-
-	or.	%r9,%r9,%r9
-	bne-	_C_LABEL(sw1)			/* at least one queue non-empty */
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	bl	_C_LABEL(sched_unlock_idle)
+	b	_C_LABEL(cpu_hatch)
+	/* NOTREACHED */
 #endif
 
-	ori	%r3,%r3,PSL_EE		/* reenable ints again */
-	mtmsr	%r3
-	isync
-	sync
-	/* low power mode */
-	mfmsr	%r3
-	oris	%r3, %r3, PSL_POW@h
-	mtmsr	%r3
-	isync
-
-/* May do some power saving here? */
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	bl	_C_LABEL(sched_lock_idle)
-#endif
-	b	_C_LABEL(idle)
-
-/*
- * switchexit gets called from cpu_exit to free the user structure
- * and kernel stack of the current process.
- */
-_ENTRY(_C_LABEL(switchexit))
-/* First switch to the idle pcb/kernel stack */
-	GET_CPUINFO(%r7)
-	lwz	%r6,CI_IDLE_PCB(%r7)
-	stw	%r6,CI_CURPCB(%r7)
-	addi	%r1,%r6,USPACE-16	/* 16 bytes are reserved at stack top */
-	/*
-	 * Schedule the vmspace and stack to be freed (the proc arg is
-	 * already in r3).
-	 */
-	bl	_C_LABEL(exit2)
-
-	/* Fall through to cpu_switch to actually select another proc */
-	li	%r3,0			/* indicate exited process */
-
-/* Fall through to cpu_switch to actually select another proc */
-
 /*
- * void cpu_switch(struct proc *p)
- * Find a runnable process and switch to it.
+ * void cpu_switchto(struct proc *old, struct proc *new)
+ * Switch from "old" proc to "new".
  */
-_ENTRY(_C_LABEL(cpu_switch))
+_ENTRY(_C_LABEL(cpu_switchto))
 	mflr	%r0			/* save lr */
 	stw	%r0,4(%r1)
 	stwu	%r1,-16(%r1)
 	stw	%r31,12(%r1)
 	stw	%r30,8(%r1)
 
-	mr	%r30,%r3
-	GET_CPUINFO(%r3)
+/*
+ * r3 - old proc
+ * r4 -	new proc
+ * r5 - cpuinfo
+ */
+	GET_CPUINFO(%r5)
 	li	%r31,0
-	/* Zero to not accumulate cpu time */
-	stw	%r31,CI_CURPROC(%r3)
-	lwz	%r31,CI_CURPCB(%r3)
-
-	li	%r3,0
-	bl	_C_LABEL(lcsplx)
-	stw	%r3,PCB_SPL(%r31)	/* save spl */
-
-/* Find a new process */
-	mfmsr	%r3
-	andi.	%r3,%r3,~PSL_EE@l	/* disable interrupts while
-					   manipulating runque */
-	mtmsr	%r3
-	isync
-
-	lis	%r8,_C_LABEL(whichqs)@ha
-	lwz	%r9,_C_LABEL(whichqs)@l(%r8)
-
-	or.	%r9,%r9,%r9
-	beq-	_C_LABEL(idle)		/* all queues empty */
-_C_LABEL(sw1):
-	cntlzw	%r10,%r9
-	lis	%r4,_C_LABEL(qs)@ha
-	addi	%r4,%r4,_C_LABEL(qs)@l
-	slwi	%r3,%r10,3
-	add	%r3,%r3,%r4		/* select queue */
-
-	lwz	%r31,P_FORW(%r3)	/* unlink first proc from queue */
-	lwz	%r4,P_FORW(%r31)
-	stw	%r4,P_FORW(%r3)
-	stw	%r3,P_BACK(%r4)
-
-	cmpl	0,%r3,%r4			/* queue empty? */
-	bne	1f
-
-	lis	%r3,0x80000000@ha
-	srw	%r3,%r3,%r10
-	andc	%r9,%r9,%r3
-	stw	%r9,_C_LABEL(whichqs)@l(%r8)	/* mark it empty */
-
-1:
 	/* just did this resched thing, clear resched */
-	li	%r3,0
-	GET_CPUINFO(%r4)
-	stw	%r3,CI_WANT_RESCHED(%r4)
-
-	stw	%r3,P_BACK(%r31)		/* probably superfluous */
+	stw	%r31,CI_WANT_RESCHED(%r5)
 
 #ifdef MULTIPROCESSOR
-	stw	%r4,P_CPU(%r31)
+	stw	%r5,P_CPU(%r4)
 #endif
 
-	stw	%r31,CI_CURPROC(%r4)		/* record new process */
-
-	li	%r3,SONPROC
-	stb	%r3,P_STAT(%r31)
+	stw	%r4,CI_CURPROC(%r5)	/* record new process */
 
-	mfmsr	%r3
-	ori	%r3,%r3,PSL_EE		/* Now we can interrupt again */
-	mtmsr	%r3
+	li	%r31,SONPROC
+	stb	%r31,P_STAT(%r4)
 
-	cmpl	0,%r31,%r30		/* is it the same process? */
-	beq	switch_return
-
-	or.	%r30,%r30,%r30		/* old process was exiting? */
+	or.	%r3,%r3,%r3		/* old process was exiting? */
 	beq	switch_exited
 
 	mfsr	%r10,PPC_USER_SR	/* save PPC_USER_SR for copyin/copyout*/
@@ -284,33 +175,31 @@
 	mr	%r12,%r2		/* save r2 */
 	stwu	%r1,-SFRAMELEN(%r1)	/* still running on old stack */
 	stmw	%r10,8(%r1)
-	lwz	%r3,P_ADDR(%r30)
-	stw	%r1,PCB_SP(%r3)		/* save SP */
+	lwz	%r31,P_ADDR(%r3)
+	stw	%r1,PCB_SP(%r31)	/* save SP */
 
 switch_exited:
 	/* disable interrupts while actually switching */
-	mfmsr	%r3
-	andi.	%r3,%r3,~PSL_EE@l
-	mtmsr	%r3
+	mfmsr	%r30
+	andi.	%r30,%r30,~PSL_EE@l
+	mtmsr	%r30
 
-	lwz	%r4,P_ADDR(%r31)
-	GET_CPUINFO(%r5)
-	stw	%r4,CI_CURPCB(%r5)	/* indicate new pcb */
+	lwz	%r31,P_ADDR(%r4)
+	stw	%r31,CI_CURPCB(%r5)	/* indicate new pcb */
 
-	lwz	%r5,PCB_PMR(%r4)
+	lwz	%r6,PCB_PMR(%r31)
 
 	/* save real pmap pointer for spill fill */
-	GET_CPUINFO(%r6)
-	stwu	%r5,CI_CURPM(%r6)
-	stwcx.	%r5,%r0,%r6		/* clear possible reservation */
+	stwu	%r6,CI_CURPM(%r5)
+	stwcx.	%r6,%r0,%r5		/* clear possible reservation */
 
-	addic.	%r5,%r5,64
-	li	%r6,0
+	addic.	%r6,%r6,64
+	li	%r5,0
 
-	lwz	%r1,PCB_SP(%r4)		/* get new procs SP */
+	lwz	%r1,PCB_SP(%r31)	/* get new procs SP */
 
-	ori	%r3,%r3,PSL_EE		/* interrupts are okay again */
-	mtmsr	%r3
+	ori	%r30,%r30,PSL_EE	/* interrupts are okay again */
+	mtmsr	%r30
 
 	lmw	%r10,8(%r1)		/* get other regs */
 	lwz	%r1,0(%r1)		/* get saved SP */
@@ -320,17 +209,6 @@
 	mtsr	PPC_USER_SR,%r10	/* get saved PPC_USER_SR */
 	isync
 
-switch_return:
-	mr	%r30,%r7		/* save proc pointer */
-	lwz	%r3,PCB_SPL(%r4)
-	bl	_C_LABEL(lcsplx)
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-        bl      _C_LABEL(sched_unlock_idle)
-#endif
-
-	mr	%r3,%r30		/* curproc for special fork returns */
-
 	lwz	%r31,12(%r1)
 	lwz	%r30,8(%r1)
 	addi	%r1,%r1,16
@@ -338,6 +216,19 @@
 	mtlr	%r0
 	blr
 
+_ENTRY(_C_LABEL(cpu_idle_enter))
+	blr
+
+_ENTRY(_C_LABEL(cpu_idle_cycle))
+	/* low power mode */
+	mfmsr	%r3
+	oris	%r3, %r3, PSL_POW@h
+	mtmsr	%r3
+	isync
+	blr
+
+_ENTRY(_C_LABEL(cpu_idle_leave))
+	blr
 
 /*
  * Data used during primary/secondary traps/interrupts
Index: arch/mips64/mips64/context.S
===================================================================
RCS file: /cvs/src/sys/arch/mips64/mips64/context.S,v
retrieving revision 1.13
diff -u -r1.13 context.S
--- arch/mips64/mips64/context.S	16 Jul 2007 20:22:18 -0000	1.13
+++ arch/mips64/mips64/context.S	25 Sep 2007 09:53:49 -0000
@@ -69,92 +69,11 @@
 	move	v0, zero
 END(savectx)
 
-/*
- * The following primitives manipulate the run queues.  _whichqs tells which
- * of the 32 queues _qs have processes in them.  Setrunqueue puts processes
- * into queues, Remrq removes them from queues.  The running process is on
- * no queue, other processes are on a queue related to p->p_priority, divided
- * by 4 actually to shrink the 0-127 range of priorities into the 32 available
- * queues.
- */
-/*
- * setrunqueue(p)
- *	proc *p;
- *
- * Call should be made at splclock(), and p->p_stat should be SRUN.
- */
-NON_LEAF(setrunqueue, FRAMESZ(CF_SZ), ra)
-	.mask	0x80000000, (CF_RA_OFFS - FRAMESZ(CF_SZ))
-	PTR_L	t0, P_BACK(a0)		## firewall: p->p_back must be 0
-	bne	t0, zero, 1f		##
-	lbu	t0, P_PRIORITY(a0)	# put on p->p_priority / 4 queue
-	li	t1, 1			# compute corresponding bit
-	srl	t0, t0, 2		# compute index into 'whichqs'
-	sll	t1, t1, t0
-	lw	t2, whichqs		# set corresponding bit
-	sll	t0, t0, LOGREGSZ+1	# compute index into 'qs'
-	or	t2, t2, t1
-	sw	t2, whichqs
-	LA	t1, qs
-	PTR_ADDU t0, t0, t1		# t0 = qp = &qs[pri >> 2]
-	PTR_L	t1, P_BACK(t0)		# t1 = qp->ph_rlink
-	PTR_S	t0, P_FORW(a0)		# p->p_forw = qp
-	PTR_S	t1, P_BACK(a0)		# p->p_back = qp->ph_rlink
-	PTR_S	a0, P_FORW(t1)		# p->p_back->p_forw = p;
-	j	ra
-	PTR_S	a0, P_BACK(t0)		# qp->ph_rlink = p
-
-1:
+NON_LEAF(cpu_idle_enter, FRAMESZ(CF_SZ), ra)
 	PTR_SUBU sp, sp, FRAMESZ(CF_SZ)
 	PTR_S	ra, CF_RA_OFFS(sp)
-	PANIC("setrunqueue")
-	jr	ra
-	nop
-END(setrunqueue)
-
-/*
- * Remrq(p)
- *
- * Call should be made at splclock().
- */
-NON_LEAF(remrunqueue, FRAMESZ(CF_SZ), ra)
 	.mask	0x80000000, (CF_RA_OFFS - FRAMESZ(CF_SZ))
-	lbu	t0, P_PRIORITY(a0)	# get from p->p_priority / 4 queue
-	li	t1, 1			# compute corresponding bit
-	srl	t0, t0, 2		# compute index into 'whichqs'
-	lw	t2, whichqs		# check corresponding bit
-	sll	t1, t1, t0
-	and	v0, t2, t1
-	beqz	v0, 2f			# oops! queue is empty!
-	PTR_L	v0, P_BACK(a0)		# v0 = p->p_back
-
-	PTR_L	v1, P_FORW(a0)		# v1 = p->p_forw
-	PTR_SLL	t0, t0, LOGREGSZ+1	# compute index into 'qs'
-	PTR_S	v1, P_FORW(v0)		# p->p_back->p_forw = p->p_forw;
-	PTR_S	v0, P_BACK(v1)		# p->p_forw->p_back = p->r_rlink
-	LA	v0, qs
-	PTR_ADDU t0, t0, v0		# t0 = qp = &qs[pri >> 2]
-	PTR_L	v0, P_FORW(t0)		# check if queue empty
-	bne	v0, t0, 1f		# No. qp->ph_link != qp
-	xor	t2, t2, t1		# clear corresponding bit in 'whichqs'
-	sw	t2, whichqs
-1:
-	j	ra
-	PTR_S	zero, P_BACK(a0)	# for firewall checking
-
-2:
-	PTR_SUBU sp, sp, FRAMESZ(CF_SZ)
-	PTR_S	ra, CF_RA_OFFS(sp)
-	PANIC("remrunqueue empty")
-	jr	ra
-	nop
-END(remrunqueue)
 
-/*
- *   Idle, this is where we spend time when nothing to do.
- */
-LEAF(idle, 0)
-_idle:
 	sw	zero, cpl		# lower to spl0
 	lw	t0, ipending
 	beqz	t0, 1f
@@ -175,63 +94,57 @@
 	jal	updateimask		# Make sure SR imask is updated
 	xor	a0, a0
 
-	li	t1,1
 #if defined(TGT_CP7000) || defined(TGT_CP7000G)
 	PTR_L	t2, misc_h		# if non zero, do Ocelot LEDs.
 	beqz	t2, 1f
 	li	t0, 0x40
 	sb	t0, 0x0d(t2)
-#endif
 1:
-	lw	t0, whichqs		# look for non-empty queue
-	beq	t0, zero, 1b
-	nop
+#endif
+
+	PTR_L	ra, CF_RA_OFFS(sp)
+	j	ra
+	PTR_ADDU sp, sp, FRAMESZ(CF_SZ)
+END(cpu_idle_enter)
+
+LEAF(cpu_idle_leave, 0)
 #if defined(TGT_CP7000) || defined(TGT_CP7000G)
-	beqz	t2, sw1
+	PTR_L	t2, misc_h		# if non zero, do Ocelot LEDs.
+	beqz	t2, 1f
 	li	t0, 0x40
 	sb	t0, 0x0c(t2)
+1:
 #endif
-	b	sw1			# Hey, time to do some work!
-	nop
-	jr	ra			# DDB trace
-	nop
-	.globl e_idle
-e_idle:
-END(idle)
 
-/*
- * switch_exit(p)
- *
- * At exit of a process, do a cpu_switch for the last time.
- * All interrupts should be blocked at this point.
- */
-LEAF(switch_exit, 0)
-	mfc0	v0, COP_0_STATUS_REG
-	li	v1, ~SR_INT_ENAB
-	and	v0, v0, v1
-	mtc0	v0, COP_0_STATUS_REG
+	mfc0	a0, COP_0_STATUS_REG	# disable interrupts
+	li	a1, ~SR_INT_ENAB
+	and	a0, a0, a1
+	mtc0	a0, COP_0_STATUS_REG
 	ITLBNOPFIX
-	LA	sp, idle_stack - FRAMESZ(CF_SZ)
-	jal	exit2
-	nop
 
-	PTR_S	zero, curproc
-	b	sw0
+	j	ra
 	nop
-	jr	ra			# DDB trace
+END(cpu_idle_leave)
+
+LEAF(cpu_idle_cycle, 0)
+	j	ra
 	nop
-END(switch_exit)
+END(cpu_idle_cycle)
 
 /*
- * cpu_switch()
- * Find the highest priority process and resume it.
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  */
-NON_LEAF(cpu_switch, FRAMESZ(CF_SZ), ra)
+NON_LEAF(cpu_switchto, FRAMESZ(CF_SZ), ra)
 	PTR_L	t3, curprocpaddr
 	REG_S	sp, PCB_CONTEXT+8*REGSZ(t3)	# save old sp
+
 	PTR_SUBU sp, sp, FRAMESZ(CF_SZ)
 	REG_S	ra, CF_RA_OFFS(sp)
 	.mask	0x80000000, (CF_RA_OFFS - FRAMESZ(CF_SZ))
+
+	beqz	a0, 1f
+	nop
+
 	lw	t0, cpl
 	REG_S	t0, PCB_CONTEXT+13*REGSZ(t3)
 	REG_S	s0, PCB_CONTEXT+0*REGSZ(t3)	# do a 'savectx()'
@@ -249,59 +162,23 @@
 	REG_S	t0, PCB_CONTEXT+11*REGSZ(t3)
 	REG_S	t1, PCB_CONTEXT+12*REGSZ(t3)
 
-sw0:
-#	lw	t2, cnt+V_SWTCH			# for statistics
-	lw	t1, whichqs			# look for non-empty queue
-#	addu	t2, t2, 1
-#	sw	t2, cnt+V_SWTCH
-	beq	t1, zero, _idle			# if none, idle
-	nop
-sw1:
-	mfc0	v0, COP_0_STATUS_REG
+1:
+	/*
+	 * Disable interrupts
+	 */
+	mfc0	v0, COP_0_STATUS_REG	# disable interrupts
 	li	v1, ~SR_INT_ENAB
 	and	v0, v0, v1
 	mtc0	v0, COP_0_STATUS_REG
 	ITLBNOPFIX
-	lw	t0, whichqs			# look for non-empty queue
-	li	t2, -1				# t2 = lowest bit set
-	beq	t0, zero, _idle			# if none, idle
-	move	t3, t0				# t3 = saved whichqs
-1:
-	addu	t2, t2, 1
-	and	t1, t0, 1			# bit set?
-	beq	t1, zero, 1b
-	srl	t0, t0, 1			# try next bit
-/*
- * Remove process from queue.
- */
-	PTR_SLL	t0, t2, LOGREGSZ+1
-	LA	t1, qs
-	PTR_ADDU t0, t0, t1			# t0 = qp = &qs[highbit]
-	PTR_L	a0, P_FORW(t0)			# a0 = p = highest pri process
-	PTR_L	v0, P_FORW(a0)			# v0 = p->p_forw
-	beq	t0, a0, 4f			# make sure something in queue
-	PTR_S	v0, P_FORW(t0)			# qp->ph_link = p->p_forw;
-	PTR_S	t0, P_BACK(v0)			# p->p_forw->p_back = qp
-	bne	v0, t0, 2f			# queue still not empty
-	PTR_S	zero, P_BACK(a0)		## for firewall checking
-	li	v1, 1				# compute bit in 'whichqs'
-	sll	v1, v1, t2
-	xor	t3, t3, v1			# clear bit in 'whichqs'
-	sw	t3, whichqs
-2:
-/*
- * Switch to new context.
- */
-	sw	zero, want_resched
-	jal	pmap_activate			# v0 = TLB PID
-	move	s0, a0				# BDSLOT: save p
 
-/*
- * We need to wire the process kernel stack mapping so there
- * will be no tlb misses in exception handlers. This is done
- * by invalidating any tlb entries mapping the U-area and
- * put valid mappings in tlb entries 0 and 1.
- */
+	/*
+	 * Switch to new context
+ 	*/
+	move	s0, a1				# save p
+	sw	zero, want_resched
+	jal	pmap_activate
+	move	a0, s0
 
 	PTR_L	t3, P_ADDR(s0)			# get uarea pointer.
 	PTR_S	s0, curproc			# set curproc
@@ -310,6 +187,13 @@
 	li	t1, SONPROC
 	sb	t1, P_STAT(s0)			# set to onproc.
 
+	/*
+	 * We need to wire the process kernel stack mapping so there
+	 * will be no tlb misses in exception handlers. This is done
+	 * by invalidating any tlb entries mapping the U-area and
+	 * put valid mappings in tlb entries 0 and 1.
+	 */
+
 	or	v0, t3
 	dmtc0	v0, COP_0_TLB_HI		# init high entry (tlbid)
 	LA	t1, (VM_MIN_KERNEL_ADDRESS)
@@ -399,9 +283,10 @@
 
 ctx3:
 
-/*
- * Restore registers and return.
- */
+	/*
+	 * Restore registers and return.
+	 */
+
 	REG_L	a0, PCB_CONTEXT+13*REGSZ(t3)
 	REG_L	s0, PCB_CONTEXT+0*REGSZ(t3)
 	REG_L	s1, PCB_CONTEXT+1*REGSZ(t3)
@@ -428,6 +313,4 @@
 	ITLBNOPFIX
 	j	ra
 	nop
-4:
-	PANIC("cpu_switch")			# nothing in queue
-END(cpu_switch)
+END(cpu_switchto)
Index: arch/mips64/mips64/db_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/mips64/mips64/db_machdep.c,v
retrieving revision 1.12
diff -u -r1.12 db_machdep.c
--- arch/mips64/mips64/db_machdep.c	3 Sep 2007 01:15:50 -0000	1.12
+++ arch/mips64/mips64/db_machdep.c	25 Sep 2007 09:53:49 -0000
@@ -221,7 +221,6 @@
 	extern char edata[];
 	extern char k_intr[];
 	extern char k_general[];
-	extern char idle[];
 	struct trap_frame *regs = &ddb_regs;
 
 	/* get initial values from the exception frame */
@@ -396,14 +395,10 @@
 	}
 
 done:
-	if (symname == NULL) {
-		if (subr == (long)idle)
-			(*pr)("idle ");
-		else
-			(*pr)("%p ", subr);
-	} else {
+	if (symname == NULL)
+		(*pr)("%p ", subr);
+	else
 		(*pr)("%s+%p ", symname, diff);
-	}
 	(*pr)("(%llx,%llx,%llx,%llx) sp %llx ra %llx, sz %d\n", a0, a1, a2, a3, sp, ra, stksize);
 
 	if (subr == (long)k_intr || subr == (long)k_general) {
Index: arch/mips64/mips64/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/mips64/mips64/vm_machdep.c,v
retrieving revision 1.15
diff -u -r1.15 vm_machdep.c
--- arch/mips64/mips64/vm_machdep.c	3 Sep 2007 17:35:51 -0000	1.15
+++ arch/mips64/mips64/vm_machdep.c	25 Sep 2007 09:53:49 -0000
@@ -134,9 +134,9 @@
 	if (machFPCurProcPtr == p)
 		machFPCurProcPtr = (struct proc *)0;
 
-	(void) splhigh();
-	switch_exit(p);
-	/* NOTREACHED */
+	(void)splhigh();
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
